./" $Id: grintro.tpl,v 2.3 89/09/20 17:01:36 mbp Exp $
./"
./" grintro.man: introductory man page for GR
./"
./" by Mark B. Phillips
./"
./" BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
./" 
./" This is a manual page "template". Before formatting to make the
./" actual manual page, this file should be edited to change the
./" following strings to whatever is appropriate:
./" 
./" MANSECTION_VALUE:
./"	extension (section numer) for man page
./" 
./" This can be done with a sed command, which is normally done by the
./" gr makefile during installation, or by the explicit command 'make
./" grintro.<n>', where <n> is the number you specify for MANEXT in
./" the Makefile.
./" 
./" EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
.TH GRINTRO MANSECTION_VALUE "September 20, 1989"
.SH NAME
grintro - introduction to GR
.SH DESCRIPTION
.PP
GR is a library of graphics procedures which provides a interface for
C programs to SunView, the Sun's windowing system.  SunView is
complicated and requires an enormous amount of overhead (both in terms
of programming effort and in program size) to use.  GR provides a
simplified interface to the some of the vector graphics and user
interaction capabilities of SunView.  This manual page gives a general
introduction to the use of GR; for details on the use of the
individual procedures, see the manual page for
.I gr(MANSECTION_VALUE).
.PP
GR is fairly simple --- it creates a window on the screen (which may
be manipulated just like any other window in Suntools) and provides
functions for drawing lines, erasing, and getting input from the user
via the mouse and the keyboard.  The window is divided into several
subwindows: a panel at the top for displaying messages to the user, a
control panel in the upper right corner, a large drawing canvas in the
middle, and a smaller error message panel across the bottom.  It also
provides a menu-control mechanism; the application program defines
(possibly more than one) menu which the user can access via the right
mouse button when the mouse is in the canvas.

.SH "WRITING, COMPILING, AND LINKING AN APPLICATION PROGRAM"
Your application program should include the header file "gr.h", which
contains various definitions and declarations which GR uses.  In
addition to being linked with the GR library itself, your program will
also need to link in the math library and the various SunView
libraries.  See the
.B SYNOPSIS
part of the manual page for
.I gr(MANSECTION_VALUE) 
for the details of how to access "gr.h" and these libraries.

.SH "SEE ALSO"
.I "gr(MANSECTION_VALUE), lgdintro(MANSECTION_VALUE), lgd(MANSECTION_VALUE)"

.SH NOTE
Although GR provides only two-dimensional graphics, there is a special
version of GR which is intended to be used in conjunction with LGD, a
3D graphics package. See the man pages for LGD for details about using
LGD.

.SH AUTHOR
Mark B. Phillips
.br
Department of Mathematics
.br
University of Maryland
.br
College Park, Maryland  20742
.br
mbp@lakisis.umd.edu
.sp1
Copyright (C) 1989 by Mark B. Phillips
.sp1
Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of Mark B. Phillips or
the University of Maryland not be used in advertising or publicity
pertaining to distribution of the software without specific, written
prior permission.  This software is provided "as is" without express
or implied warranty.
