/* $Id: image_info.h,v 2.3 89/09/20 17:01:39 mbp Exp $
 *
 * image_info.h: information about images used in panels
 */

/************************************************************************
 *		Copyright (C) 1989 by Mark B. Phillips                  *
 * 									*
 * Permission to use, copy, modify, and distribute this software and    *
 * its documentation for any purpose and without fee is hereby granted, *
 * provided that the above copyright notice appear in all copies and    *
 * that both that copyright notice and this permission notice appear in *
 * supporting documentation, and that the name of Mark B. Phillips or   *
 * the University of Maryland not be used in advertising or publicity   *
 * pertaining to distribution of the software without specific, written *
 * prior permission.  This software is provided "as is" without express *
 * or implied warranty.                                                 *
 ************************************************************************/


/* The images used for panel buttons and messages were all created
 * with iconedit(1) and then cut down to size using the shell script
 * cut_icon.  The size of each image is given in the table below;
 * these dimensions must be known at compile for passing to the
 * SunView macro "mpr_static".
 *
 * NOTE: if iconedit is used to edit any of these images, the result
 * must be re-cut down to size using cut_icon; iconedit always writes
 * 64x64 icons.  (Unless the "size" is set to "cursor", in which case
 * it is 16x16).
 */

/* Panel Item		File Name	Width	Height	*/

/* left mouse		lmouse.image			*/
#define LMOUSE_W			16
#define LMOUSE_H				15

/* middle mouse		mmouse.image			*/
#define MMOUSE_W			16
#define MMOUSE_H				15

/* right mouse		rmouse.image			*/
#define RMOUSE_W			16
#define RMOUSE_H				15

/* shift + left mouse	lsmouse.image			*/
#define LSMOUSE_W			16
#define LSMOUSE_H				21

/* shift + middle mouse	msmouse.image			*/
#define MSMOUSE_W			16
#define MSMOUSE_H				21

/* shift + right mouse	rsmouse.image			*/
#define RSMOUSE_W			16
#define RSMOUSE_H				21

/* Esc key		esc.image			*/
#define ESC_W				16
#define ESC_H					16

/* View Control Buttons	(various)			*/
#define VCB_W				48
#define VCB_H					48
