./" $Id: lgdintro.tpl,v 1.7 89/09/20 17:49:18 mbp Exp $
./"
./" lgdintro.?: introductory manual page for LGD
./"
./" by Mark B. Phillips
./"
./" BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
./" 
./" This is a manual page "template". Before formatting to make the
./" actual manual page, this file should be edited to change the
./" following strings to whatever is appropriate for your system:
./" 
./" MANSECTION_VALUE:
./"	extension (section numer) for man page
./" 
./" This can be done with a sed command, which is normally done by the
./" lgd makefile during installation, or by the explicit command 'make
./" lgdintro.<n>', where <n> is the number you specify for MANEXT in
./" the Makefile.
./" 
./" EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
.TH LGDINTRO MANSECTION_VALUE "September 19, 1989"
.SH NAME
lgdintro - introduction to LGD
.SH DESCRIPTION
.LP
LGD is a simple 3-dimensional vector graphics package.  The name LGD
stands for "Logical Graphics Device", and is meant to indicate the
device independent nature of the LGD.  The general philosophy of LGD
is to provide an abstract 3-dimensional graphics device in which an
application program can create a "world" of vectors.  This graphics
device gives the user interactive control over how this world is
viewed.  This frees up the application program to concentrate on the
job of creating and managing this "world", rather than on how it is
displayed.  The exact manner in which this device is implemented
varies from one type of computer to another, but the same programming
interface is used in all cases, so that an LGD program written on
one computer will work without modification on another.

The "logical device" can
.PP
.IP \(bu
display a collection of vectors in three-dimensional
space and gives the user interactive control over the
viewing transformation.
.IP \(bu
draw vectors in a variety of colors, at least in as much as the
particular graphics screen being drawn on allows.
.IP \(bu
keep track of groups, or segments, of vectors which can be manipulated
as a unit for various operations such as user selection, temporary
hiding, or permanent deletion.
.IP \(bu
handle I/O to and from the user without interfering with the graphics
display.
.IP \(bu
give the user a menu of options to choose from, and perform various
actions based on the choices the user makes.
.IP \(bu
get a point in 3-space from the user.
.IP \(bu
get a segment picked by the user
.IP \(bu
save a file of vectors in a disk file which can be reloaded at a later
time for further viewing and/or modification.
.IP \(bu
print out a hardcopy of the picture.
.PP
LGD is simple in that it only displays vectors (no shaded surfaces, or
hidden-line removal, etc) and does not support a sophisticated
hierarchy of data objects (segments cannot be nested).  Because of its
simplicity, however, LGD does not require the large amount of overhead
used by many 3D graphics packages.  Thus for applications which only
need to draw reasonably simple line or point drawings in 3-space, LGD
provides a fast-running, easy to use graphics environment.
.PP
To write a program which uses LGD, see
lgd(MANSECTION_VALUE) for a description
of the individual procedures and how to use them.
.SH "SEE ALSO"
lgd(MANSECTION_VALUE)
.SH AUTHOR
Mark B. Phillips
.br
Department of Mathematics
.br
University of Maryland
.br
College Park, Maryland  20742
.br
mbp@lakisis.umd.edu
.sp1
Copyright (C) 1989 by Mark B. Phillips
.sp1
Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of Mark B. Phillips or
the University of Maryland not be used in advertising or publicity
pertaining to distribution of the software without specific, written
prior permission.  This software is provided "as is" without express
or implied warranty.
